<template>
  <div class="admin">
    <nuxt-child />
  </div>
</template>

<script lang="ts">
import { defineComponent, provide, ref } from '@nuxtjs/composition-api'
import { AdminPagesProvider } from '@/types/admin'
import { useAdminPagesSubscription, useAdminGetPagesQuery } from '@/sdk/hooks'
import { PageWithLocalesFragment } from '~/sdk/types'

export default defineComponent({
  layout: 'admin',
  middleware: ['admin'],
  name: 'AdminPage',
  setup() {
    // provide pages subscription
    const { onResult } = useAdminPagesSubscription({})
    const pages = ref<PageWithLocalesFragment[]>([])
    const { onResult: onQueryResult } = useAdminGetPagesQuery()
    onQueryResult(result => {
      if (result?.data) pages.value = result.data.pages
    })
    onResult(result => {
      if (result?.data) pages.value = result.data.pages
    })
    provide(AdminPagesProvider, pages)
  }
})
</script>

<style lang="scss" scoped>
.admin {
  &__menu {
    list-style: none;
    display: flex;
    flex-wrap: wrap;
    padding: 0;
    a {
      font-size: 30px;
      line-height: 45px;
      letter-spacing: 0px;
      color: #8591ad;
      margin: 0 30px 15px 0;

      &.is-active {
        color: var(--color-light);
      }
      &:hover {
        color: var(--color-light);
      }
    }
  }
}
</style>
